"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.PdfHighlighter = void 0;
var react_1 = __importStar(require("react"));
var react_dom_1 = __importDefault(require("react-dom"));
var lodash_debounce_1 = __importDefault(require("lodash.debounce"));
var pdf_viewer_1 = require("pdfjs-dist/legacy/web/pdf_viewer");
require("pdfjs-dist/web/pdf_viewer.css");
require("../style/pdf_viewer.css");
require("../style/PdfHighlighter.css");
var get_bounding_rect_1 = __importDefault(require("../lib/get-bounding-rect"));
var get_client_rects_1 = __importDefault(require("../lib/get-client-rects"));
var get_area_as_png_1 = __importDefault(require("../lib/get-area-as-png"));
var pdfjs_dom_1 = require("../lib/pdfjs-dom");
var TipContainer_1 = __importDefault(require("./TipContainer"));
var MouseSelection_1 = __importDefault(require("./MouseSelection"));
var coordinates_1 = require("../lib/coordinates");
var EMPTY_ID = "empty-id";
var PdfHighlighter = /** @class */ (function (_super) {
    __extends(PdfHighlighter, _super);
    function PdfHighlighter(props) {
        var _this = _super.call(this, props) || this;
        _this.state = {
            ghostHighlight: null,
            isCollapsed: true,
            range: null,
            scrolledToHighlightId: EMPTY_ID,
            isAreaSelectionInProgress: false,
            tip: null,
            tipPosition: null,
            tipChildren: null,
        };
        _this.eventBus = new pdf_viewer_1.EventBus();
        _this.linkService = new pdf_viewer_1.PDFLinkService({
            eventBus: _this.eventBus,
            externalLinkTarget: 2,
        });
        _this.resizeObserver = null;
        _this.containerNode = null;
        _this.unsubscribe = function () { };
        _this.attachRef = function (ref) {
            var _a;
            var _b = _this, eventBus = _b.eventBus, observer = _b.resizeObserver;
            _this.containerNode = ref;
            _this.unsubscribe();
            if (ref) {
                var doc_1 = ref.ownerDocument;
                eventBus.on("textlayerrendered", _this.onTextLayerRendered);
                eventBus.on("pagesinit", _this.onDocumentReady);
                doc_1.addEventListener("selectionchange", _this.onSelectionChange);
                doc_1.addEventListener("keydown", _this.handleKeyDown);
                (_a = doc_1.defaultView) === null || _a === void 0 ? void 0 : _a.addEventListener("resize", _this.debouncedScaleValue);
                if (observer)
                    observer.observe(ref);
                _this.unsubscribe = function () {
                    var _a;
                    eventBus.off("pagesinit", _this.onDocumentReady);
                    eventBus.off("textlayerrendered", _this.onTextLayerRendered);
                    doc_1.removeEventListener("selectionchange", _this.onSelectionChange);
                    doc_1.removeEventListener("keydown", _this.handleKeyDown);
                    (_a = doc_1.defaultView) === null || _a === void 0 ? void 0 : _a.removeEventListener("resize", _this.debouncedScaleValue);
                    if (observer)
                        observer.disconnect();
                };
            }
        };
        _this.hideTipAndSelection = function () {
            _this.setState({
                tipPosition: null,
                tipChildren: null,
            });
            _this.setState({ ghostHighlight: null, tip: null }, function () {
                return _this.renderHighlights();
            });
        };
        _this.renderTip = function () {
            var _a = _this.state, tipPosition = _a.tipPosition, tipChildren = _a.tipChildren;
            if (!tipPosition)
                return null;
            var boundingRect = tipPosition.boundingRect, pageNumber = tipPosition.pageNumber;
            var page = {
                node: _this.viewer.getPageView((boundingRect.pageNumber || pageNumber) - 1)
                    .div,
                pageNumber: boundingRect.pageNumber || pageNumber,
            };
            var pageBoundingClientRect = page.node.getBoundingClientRect();
            var pageBoundingRect = {
                bottom: pageBoundingClientRect.bottom,
                height: pageBoundingClientRect.height,
                left: pageBoundingClientRect.left,
                right: pageBoundingClientRect.right,
                top: pageBoundingClientRect.top,
                width: pageBoundingClientRect.width,
                x: pageBoundingClientRect.x,
                y: pageBoundingClientRect.y,
                pageNumber: page.pageNumber,
            };
            return (react_1.default.createElement(TipContainer_1.default, { scrollTop: _this.viewer.container.scrollTop, pageBoundingRect: pageBoundingRect, style: {
                    left: page.node.offsetLeft + boundingRect.left + boundingRect.width / 2,
                    top: boundingRect.top + page.node.offsetTop,
                    bottom: boundingRect.top + page.node.offsetTop + boundingRect.height,
                } }, tipChildren));
        };
        _this.onTextLayerRendered = function () {
            _this.renderHighlights();
        };
        _this.scrollTo = function (highlight) {
            var _a = highlight.position, pageNumber = _a.pageNumber, boundingRect = _a.boundingRect, usePdfCoordinates = _a.usePdfCoordinates;
            _this.viewer.container.removeEventListener("scroll", _this.onScroll);
            var pageViewport = _this.viewer.getPageView(pageNumber - 1).viewport;
            var scrollMargin = 10;
            _this.viewer.scrollPageIntoView({
                pageNumber: pageNumber,
                destArray: __spreadArray(__spreadArray([
                    null,
                    { name: "XYZ" }
                ], pageViewport.convertToPdfPoint(0, (0, coordinates_1.scaledToViewport)(boundingRect, pageViewport, usePdfCoordinates).top -
                    scrollMargin), true), [
                    0,
                ], false),
            });
            _this.setState({
                scrolledToHighlightId: highlight.id,
            }, function () { return _this.renderHighlights(); });
            // wait for scrolling to finish
            setTimeout(function () {
                _this.viewer.container.addEventListener("scroll", _this.onScroll);
            }, 100);
        };
        _this.onDocumentReady = function () {
            var scrollRef = _this.props.scrollRef;
            _this.handleScaleValue();
            scrollRef(_this.scrollTo);
        };
        _this.onSelectionChange = function () {
            var container = _this.containerNode;
            var selection = (0, pdfjs_dom_1.getWindow)(container).getSelection();
            if (!selection) {
                return;
            }
            var range = selection.rangeCount > 0 ? selection.getRangeAt(0) : null;
            if (selection.isCollapsed) {
                _this.setState({ isCollapsed: true });
                return;
            }
            if (!range ||
                !container ||
                !container.contains(range.commonAncestorContainer)) {
                return;
            }
            _this.setState({
                isCollapsed: false,
                range: range,
            });
            _this.debouncedAfterSelection();
        };
        _this.onScroll = function () {
            var onScrollChange = _this.props.onScrollChange;
            onScrollChange();
            _this.setState({
                scrolledToHighlightId: EMPTY_ID,
            }, function () { return _this.renderHighlights(); });
            _this.viewer.container.removeEventListener("scroll", _this.onScroll);
        };
        _this.onMouseDown = function (event) {
            if (!(0, pdfjs_dom_1.isHTMLElement)(event.target)) {
                return;
            }
            if ((0, pdfjs_dom_1.asElement)(event.target).closest(".PdfHighlighter__tip-container")) {
                return;
            }
            _this.hideTipAndSelection();
        };
        _this.handleKeyDown = function (event) {
            if (event.code === "Escape") {
                _this.hideTipAndSelection();
            }
        };
        _this.afterSelection = function () {
            var onSelectionFinished = _this.props.onSelectionFinished;
            var _a = _this.state, isCollapsed = _a.isCollapsed, range = _a.range;
            if (!range || isCollapsed) {
                return;
            }
            var pages = (0, pdfjs_dom_1.getPagesFromRange)(range);
            if (!pages || pages.length === 0) {
                return;
            }
            var rects = (0, get_client_rects_1.default)(range, pages);
            if (rects.length === 0) {
                return;
            }
            var boundingRect = (0, get_bounding_rect_1.default)(rects);
            var viewportPosition = {
                boundingRect: boundingRect,
                rects: rects,
                pageNumber: pages[0].number,
            };
            var content = {
                text: range.toString(),
            };
            var scaledPosition = _this.viewportPositionToScaled(viewportPosition);
            _this.setTip(viewportPosition, onSelectionFinished(scaledPosition, content, function () { return _this.hideTipAndSelection(); }, function () {
                return _this.setState({
                    ghostHighlight: { position: scaledPosition },
                }, function () { return _this.renderHighlights(); });
            }));
        };
        _this.debouncedAfterSelection = (0, lodash_debounce_1.default)(_this.afterSelection, 500);
        _this.handleScaleValue = function () {
            if (_this.viewer) {
                _this.viewer.currentScaleValue = _this.props.pdfScaleValue; //"page-width";
            }
        };
        _this.debouncedScaleValue = (0, lodash_debounce_1.default)(_this.handleScaleValue, 500);
        if (typeof ResizeObserver !== "undefined") {
            _this.resizeObserver = new ResizeObserver(_this.debouncedScaleValue);
        }
        return _this;
    }
    PdfHighlighter.prototype.componentDidMount = function () {
        this.init();
    };
    PdfHighlighter.prototype.componentDidUpdate = function (prevProps) {
        if (prevProps.pdfDocument !== this.props.pdfDocument) {
            this.init();
            return;
        }
        if (prevProps.highlights !== this.props.highlights) {
            this.renderHighlights(this.props);
        }
    };
    PdfHighlighter.prototype.init = function () {
        var pdfDocument = this.props.pdfDocument;
        this.viewer =
            this.viewer ||
                new pdf_viewer_1.PDFViewer({
                    container: this.containerNode,
                    eventBus: this.eventBus,
                    enhanceTextSelection: true,
                    removePageBorders: true,
                    linkService: this.linkService,
                });
        this.linkService.setDocument(pdfDocument);
        this.linkService.setViewer(this.viewer);
        this.viewer.setDocument(pdfDocument);
        // debug
        window.PdfViewer = this;
    };
    PdfHighlighter.prototype.componentWillUnmount = function () {
        this.unsubscribe();
    };
    PdfHighlighter.prototype.findOrCreateHighlightLayer = function (page) {
        var textLayer = (this.viewer.getPageView(page - 1) || {}).textLayer;
        if (!textLayer) {
            return null;
        }
        return (0, pdfjs_dom_1.findOrCreateContainerLayer)(textLayer.textLayerDiv, "PdfHighlighter__highlight-layer");
    };
    PdfHighlighter.prototype.groupHighlightsByPage = function (highlights) {
        var ghostHighlight = this.state.ghostHighlight;
        var allHighlights = __spreadArray(__spreadArray([], highlights, true), [ghostHighlight], false).filter(Boolean);
        var pageNumbers = new Set();
        for (var _i = 0, allHighlights_1 = allHighlights; _i < allHighlights_1.length; _i++) {
            var highlight = allHighlights_1[_i];
            pageNumbers.add(highlight.position.pageNumber);
            for (var _a = 0, _b = highlight.position.rects; _a < _b.length; _a++) {
                var rect = _b[_a];
                if (rect.pageNumber) {
                    pageNumbers.add(rect.pageNumber);
                }
            }
        }
        var groupedHighlights = {};
        for (var pageNumber = 0; pageNumber <= pageNumbers.size; pageNumber++) {
            groupedHighlights[pageNumber] = groupedHighlights[pageNumber] || [];
            for (var _c = 0, allHighlights_2 = allHighlights; _c < allHighlights_2.length; _c++) {
                var highlight = allHighlights_2[_c];
                var pageSpecificHighlight = __assign(__assign({}, highlight), { position: {
                        pageNumber: pageNumber,
                        boundingRect: highlight.position.boundingRect,
                        rects: [],
                        usePdfCoordinates: highlight.position.usePdfCoordinates,
                    } });
                var anyRectsOnPage = false;
                for (var _d = 0, _e = highlight.position.rects; _d < _e.length; _d++) {
                    var rect = _e[_d];
                    if (pageNumber === (rect.pageNumber || highlight.position.pageNumber)) {
                        pageSpecificHighlight.position.rects.push(rect);
                        anyRectsOnPage = true;
                    }
                }
                if (anyRectsOnPage || pageNumber === highlight.position.pageNumber) {
                    groupedHighlights[pageNumber].push(pageSpecificHighlight);
                }
            }
        }
        return groupedHighlights;
    };
    PdfHighlighter.prototype.showTip = function (highlight, content) {
        var _a = this.state, isCollapsed = _a.isCollapsed, ghostHighlight = _a.ghostHighlight, isAreaSelectionInProgress = _a.isAreaSelectionInProgress;
        var highlightInProgress = !isCollapsed || ghostHighlight;
        if (highlightInProgress || isAreaSelectionInProgress) {
            return;
        }
        this.setTip(highlight.position, content);
    };
    PdfHighlighter.prototype.scaledPositionToViewport = function (_a) {
        var pageNumber = _a.pageNumber, boundingRect = _a.boundingRect, rects = _a.rects, usePdfCoordinates = _a.usePdfCoordinates;
        var viewport = this.viewer.getPageView(pageNumber - 1).viewport;
        return {
            boundingRect: (0, coordinates_1.scaledToViewport)(boundingRect, viewport, usePdfCoordinates),
            rects: (rects || []).map(function (rect) {
                return (0, coordinates_1.scaledToViewport)(rect, viewport, usePdfCoordinates);
            }),
            pageNumber: pageNumber,
        };
    };
    PdfHighlighter.prototype.viewportPositionToScaled = function (_a) {
        var pageNumber = _a.pageNumber, boundingRect = _a.boundingRect, rects = _a.rects;
        var viewport = this.viewer.getPageView(pageNumber - 1).viewport;
        return {
            boundingRect: (0, coordinates_1.viewportToScaled)(boundingRect, viewport),
            rects: (rects || []).map(function (rect) { return (0, coordinates_1.viewportToScaled)(rect, viewport); }),
            pageNumber: pageNumber,
        };
    };
    PdfHighlighter.prototype.screenshot = function (position, pageNumber) {
        var canvas = this.viewer.getPageView(pageNumber - 1).canvas;
        return (0, get_area_as_png_1.default)(canvas, position);
    };
    PdfHighlighter.prototype.renderHighlights = function (nextProps) {
        var _this = this;
        var _a = nextProps || this.props, highlightTransform = _a.highlightTransform, highlights = _a.highlights;
        var pdfDocument = this.props.pdfDocument;
        var _b = this.state, tip = _b.tip, scrolledToHighlightId = _b.scrolledToHighlightId;
        var highlightsByPage = this.groupHighlightsByPage(highlights);
        var _loop_1 = function (pageNumber) {
            var highlightLayer = this_1.findOrCreateHighlightLayer(pageNumber);
            if (highlightLayer) {
                react_dom_1.default.render(react_1.default.createElement("div", null, (highlightsByPage[String(pageNumber)] || []).map(function (_a, index) {
                    var position = _a.position, id = _a.id, highlight = __rest(_a, ["position", "id"]);
                    // @ts-ignore
                    var viewportHighlight = __assign({ id: id, position: _this.scaledPositionToViewport(position) }, highlight);
                    if (tip && tip.highlight.id === String(id)) {
                        _this.showTip(tip.highlight, tip.callback(viewportHighlight));
                    }
                    var isScrolledTo = Boolean(scrolledToHighlightId === id);
                    return highlightTransform(viewportHighlight, index, function (highlight, callback) {
                        _this.setState({
                            tip: { highlight: highlight, callback: callback },
                        });
                        _this.showTip(highlight, callback(highlight));
                    }, _this.hideTipAndSelection, function (rect) {
                        var viewport = _this.viewer.getPageView((rect.pageNumber || pageNumber) - 1).viewport;
                        return (0, coordinates_1.viewportToScaled)(rect, viewport);
                    }, function (boundingRect) { return _this.screenshot(boundingRect, pageNumber); }, isScrolledTo);
                })), highlightLayer);
            }
        };
        var this_1 = this;
        for (var pageNumber = 1; pageNumber <= pdfDocument.numPages; pageNumber++) {
            _loop_1(pageNumber);
        }
    };
    PdfHighlighter.prototype.setTip = function (position, inner) {
        this.setState({
            tipPosition: position,
            tipChildren: inner,
        });
    };
    PdfHighlighter.prototype.toggleTextSelection = function (flag) {
        this.viewer.viewer.classList.toggle("PdfHighlighter--disable-selection", flag);
    };
    PdfHighlighter.prototype.render = function () {
        var _this = this;
        var _a = this.props, onSelectionFinished = _a.onSelectionFinished, enableAreaSelection = _a.enableAreaSelection;
        return (react_1.default.createElement("div", { onPointerDown: this.onMouseDown },
            react_1.default.createElement("div", { ref: this.attachRef, className: "PdfHighlighter", onContextMenu: function (e) { return e.preventDefault(); } },
                react_1.default.createElement("div", { className: "pdfViewer" }),
                this.renderTip(),
                typeof enableAreaSelection === "function" ? (react_1.default.createElement(MouseSelection_1.default, { onDragStart: function () { return _this.toggleTextSelection(true); }, onDragEnd: function () { return _this.toggleTextSelection(false); }, onChange: function (isVisible) {
                        return _this.setState({ isAreaSelectionInProgress: isVisible });
                    }, shouldStart: function (event) {
                        return enableAreaSelection(event) &&
                            (0, pdfjs_dom_1.isHTMLElement)(event.target) &&
                            Boolean((0, pdfjs_dom_1.asElement)(event.target).closest(".page"));
                    }, onSelection: function (startTarget, boundingRect, resetSelection) {
                        var page = (0, pdfjs_dom_1.getPageFromElement)(startTarget);
                        if (!page) {
                            return;
                        }
                        var pageBoundingRect = __assign(__assign({}, boundingRect), { top: boundingRect.top - page.node.offsetTop, left: boundingRect.left - page.node.offsetLeft, pageNumber: page.number });
                        var viewportPosition = {
                            boundingRect: pageBoundingRect,
                            rects: [],
                            pageNumber: page.number,
                        };
                        var scaledPosition = _this.viewportPositionToScaled(viewportPosition);
                        var image = _this.screenshot(pageBoundingRect, pageBoundingRect.pageNumber);
                        _this.setTip(viewportPosition, onSelectionFinished(scaledPosition, { image: image }, function () { return _this.hideTipAndSelection(); }, function () {
                            return _this.setState({
                                ghostHighlight: {
                                    position: scaledPosition,
                                    content: { image: image },
                                },
                            }, function () {
                                resetSelection();
                                _this.renderHighlights();
                            });
                        }));
                    } })) : null)));
    };
    PdfHighlighter.defaultProps = {
        pdfScaleValue: "auto",
    };
    return PdfHighlighter;
}(react_1.PureComponent));
exports.PdfHighlighter = PdfHighlighter;
//# sourceMappingURL=PdfHighlighter.js.map