"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.PdfLoader = void 0;
var react_1 = __importStar(require("react"));
var pdf_1 = require("pdfjs-dist/legacy/build/pdf");
var PdfLoader = /** @class */ (function (_super) {
    __extends(PdfLoader, _super);
    function PdfLoader() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.state = {
            pdfDocument: null,
            error: null,
        };
        _this.documentRef = react_1.default.createRef();
        return _this;
    }
    PdfLoader.prototype.componentDidMount = function () {
        this.load();
    };
    PdfLoader.prototype.componentWillUnmount = function () {
        var discardedDocument = this.state.pdfDocument;
        if (discardedDocument) {
            discardedDocument.destroy();
        }
    };
    PdfLoader.prototype.componentDidUpdate = function (_a) {
        var url = _a.url;
        if (this.props.url !== url) {
            this.load();
        }
    };
    PdfLoader.prototype.componentDidCatch = function (error, info) {
        var onError = this.props.onError;
        if (onError) {
            onError(error);
        }
        this.setState({ pdfDocument: null, error: error });
    };
    PdfLoader.prototype.load = function () {
        var _this = this;
        var _a = (this.documentRef.current || {}).ownerDocument, ownerDocument = _a === void 0 ? document : _a;
        var _b = this.props, url = _b.url, cMapUrl = _b.cMapUrl, cMapPacked = _b.cMapPacked, workerSrc = _b.workerSrc;
        var discardedDocument = this.state.pdfDocument;
        this.setState({ pdfDocument: null, error: null });
        if (typeof workerSrc === "string") {
            pdf_1.GlobalWorkerOptions.workerSrc = workerSrc;
        }
        Promise.resolve()
            .then(function () { return discardedDocument && discardedDocument.destroy(); })
            .then(function () {
            if (!url) {
                return;
            }
            return (0, pdf_1.getDocument)(__assign(__assign({}, _this.props), { ownerDocument: ownerDocument, cMapUrl: cMapUrl, cMapPacked: cMapPacked })).promise.then(function (pdfDocument) {
                _this.setState({ pdfDocument: pdfDocument });
            });
        })
            .catch(function (e) { return _this.componentDidCatch(e); });
    };
    PdfLoader.prototype.render = function () {
        var _a = this.props, children = _a.children, beforeLoad = _a.beforeLoad;
        var _b = this.state, pdfDocument = _b.pdfDocument, error = _b.error;
        return (react_1.default.createElement(react_1.default.Fragment, null,
            react_1.default.createElement("span", { ref: this.documentRef }),
            error
                ? this.renderError()
                : !pdfDocument || !children
                    ? beforeLoad
                    : children(pdfDocument)));
    };
    PdfLoader.prototype.renderError = function () {
        var errorMessage = this.props.errorMessage;
        if (errorMessage) {
            return react_1.default.cloneElement(errorMessage, { error: this.state.error });
        }
        return null;
    };
    PdfLoader.defaultProps = {
        workerSrc: "https://unpkg.com/pdfjs-dist@2.8.335/build/pdf.worker.min.js",
    };
    return PdfLoader;
}(react_1.Component));
exports.PdfLoader = PdfLoader;
exports.default = PdfLoader;
//# sourceMappingURL=PdfLoader.js.map