"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
var react_1 = __importStar(require("react"));
var clamp = function (value, left, right) {
    return Math.min(Math.max(value, left), right);
};
var TipContainer = /** @class */ (function (_super) {
    __extends(TipContainer, _super);
    function TipContainer() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.state = {
            height: 0,
            width: 0,
        };
        _this.node = null;
        _this.updatePosition = function () {
            if (!_this.node) {
                return;
            }
            var _a = _this.node, offsetHeight = _a.offsetHeight, offsetWidth = _a.offsetWidth;
            _this.setState({
                height: offsetHeight,
                width: offsetWidth,
            });
        };
        return _this;
    }
    TipContainer.prototype.componentDidUpdate = function (nextProps) {
        if (this.props.children !== nextProps.children) {
            this.updatePosition();
        }
    };
    TipContainer.prototype.componentDidMount = function () {
        setTimeout(this.updatePosition, 0);
    };
    TipContainer.prototype.render = function () {
        var _this = this;
        var _a = this.props, children = _a.children, style = _a.style, scrollTop = _a.scrollTop, pageBoundingRect = _a.pageBoundingRect;
        var _b = this.state, height = _b.height, width = _b.width;
        var isStyleCalculationInProgress = width === 0 && height === 0;
        var shouldMove = style.top - height - 5 < scrollTop;
        var top = shouldMove ? style.bottom + 5 : style.top - height - 5;
        var left = clamp(style.left - width / 2, 0, pageBoundingRect.width - width);
        var childrenWithProps = react_1.default.Children.map(children, function (child) {
            // @ts-ignore
            return react_1.default.cloneElement(child, {
                onUpdate: function () {
                    _this.setState({
                        width: 0,
                        height: 0,
                    }, function () {
                        setTimeout(_this.updatePosition, 0);
                    });
                },
                popup: {
                    position: shouldMove ? "below" : "above",
                },
            });
        });
        return (react_1.default.createElement("div", { className: "PdfHighlighter__tip-container", style: {
                visibility: isStyleCalculationInProgress ? "hidden" : "visible",
                top: top,
                left: left,
            }, ref: function (node) {
                _this.node = node;
            } }, childrenWithProps));
    };
    return TipContainer;
}(react_1.Component));
exports.default = TipContainer;
//# sourceMappingURL=TipContainer.js.map