"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var pdfjs_dom_1 = require("./pdfjs-dom");
var getAreaAsPNG = function (canvas, position) {
    var left = position.left, top = position.top, width = position.width, height = position.height;
    var doc = canvas ? canvas.ownerDocument : null;
    // @TODO: cache this?
    var newCanvas = doc && doc.createElement("canvas");
    if (!newCanvas || !(0, pdfjs_dom_1.isHTMLCanvasElement)(newCanvas)) {
        return "";
    }
    newCanvas.width = width;
    newCanvas.height = height;
    var newCanvasContext = newCanvas.getContext("2d");
    if (!newCanvasContext || !canvas) {
        return "";
    }
    var dpr = window.devicePixelRatio;
    newCanvasContext.drawImage(canvas, left * dpr, top * dpr, width * dpr, height * dpr, 0, 0, width, height);
    return newCanvas.toDataURL("image/png");
};
exports.default = getAreaAsPNG;
//# sourceMappingURL=get-area-as-png.js.map