var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
import React, { Component } from "react";
var MouseMonitor = /** @class */ (function (_super) {
    __extends(MouseMonitor, _super);
    function MouseMonitor() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.container = null;
        _this.unsubscribe = function () { };
        _this.onMouseMove = function (event) {
            if (!_this.container) {
                return;
            }
            var _a = _this.props, onMoveAway = _a.onMoveAway, paddingX = _a.paddingX, paddingY = _a.paddingY;
            var clientX = event.clientX, clientY = event.clientY;
            // TODO: see if possible to optimize
            var _b = _this.container.getBoundingClientRect(), left = _b.left, top = _b.top, width = _b.width, height = _b.height;
            var inBoundsX = clientX > left - paddingX && clientX < left + width + paddingX;
            var inBoundsY = clientY > top - paddingY && clientY < top + height + paddingY;
            var isNear = inBoundsX && inBoundsY;
            if (!isNear) {
                onMoveAway();
            }
        };
        _this.attachRef = function (ref) {
            _this.container = ref;
            _this.unsubscribe();
            if (ref) {
                var doc_1 = ref.ownerDocument;
                doc_1.addEventListener("mousemove", _this.onMouseMove);
                _this.unsubscribe = function () {
                    doc_1.removeEventListener("mousemove", _this.onMouseMove);
                };
            }
        };
        return _this;
    }
    MouseMonitor.prototype.render = function () {
        // eslint-disable-next-line
        var _a = this.props, onMoveAway = _a.onMoveAway, paddingX = _a.paddingX, paddingY = _a.paddingY, children = _a.children, restProps = __rest(_a, ["onMoveAway", "paddingX", "paddingY", "children"]);
        return (React.createElement("div", { ref: this.attachRef }, React.cloneElement(children, restProps)));
    };
    return MouseMonitor;
}(Component));
export default MouseMonitor;
//# sourceMappingURL=MouseMonitor.js.map