var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
import React, { Component } from "react";
import { getDocument, GlobalWorkerOptions } from "pdfjs-dist/legacy/build/pdf";
var PdfLoader = /** @class */ (function (_super) {
    __extends(PdfLoader, _super);
    function PdfLoader() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.state = {
            pdfDocument: null,
            error: null,
        };
        _this.documentRef = React.createRef();
        return _this;
    }
    PdfLoader.prototype.componentDidMount = function () {
        this.load();
    };
    PdfLoader.prototype.componentWillUnmount = function () {
        var discardedDocument = this.state.pdfDocument;
        if (discardedDocument) {
            discardedDocument.destroy();
        }
    };
    PdfLoader.prototype.componentDidUpdate = function (_a) {
        var url = _a.url;
        if (this.props.url !== url) {
            this.load();
        }
    };
    PdfLoader.prototype.componentDidCatch = function (error, info) {
        var onError = this.props.onError;
        if (onError) {
            onError(error);
        }
        this.setState({ pdfDocument: null, error: error });
    };
    PdfLoader.prototype.load = function () {
        var _this = this;
        var _a = (this.documentRef.current || {}).ownerDocument, ownerDocument = _a === void 0 ? document : _a;
        var _b = this.props, url = _b.url, cMapUrl = _b.cMapUrl, cMapPacked = _b.cMapPacked, workerSrc = _b.workerSrc;
        var discardedDocument = this.state.pdfDocument;
        this.setState({ pdfDocument: null, error: null });
        if (typeof workerSrc === "string") {
            GlobalWorkerOptions.workerSrc = workerSrc;
        }
        Promise.resolve()
            .then(function () { return discardedDocument && discardedDocument.destroy(); })
            .then(function () {
            if (!url) {
                return;
            }
            return getDocument(__assign(__assign({}, _this.props), { ownerDocument: ownerDocument, cMapUrl: cMapUrl, cMapPacked: cMapPacked })).promise.then(function (pdfDocument) {
                _this.setState({ pdfDocument: pdfDocument });
            });
        })
            .catch(function (e) { return _this.componentDidCatch(e); });
    };
    PdfLoader.prototype.render = function () {
        var _a = this.props, children = _a.children, beforeLoad = _a.beforeLoad;
        var _b = this.state, pdfDocument = _b.pdfDocument, error = _b.error;
        return (React.createElement(React.Fragment, null,
            React.createElement("span", { ref: this.documentRef }),
            error
                ? this.renderError()
                : !pdfDocument || !children
                    ? beforeLoad
                    : children(pdfDocument)));
    };
    PdfLoader.prototype.renderError = function () {
        var errorMessage = this.props.errorMessage;
        if (errorMessage) {
            return React.cloneElement(errorMessage, { error: this.state.error });
        }
        return null;
    };
    PdfLoader.defaultProps = {
        workerSrc: "https://unpkg.com/pdfjs-dist@2.8.335/build/pdf.worker.min.js",
    };
    return PdfLoader;
}(Component));
export { PdfLoader };
export default PdfLoader;
//# sourceMappingURL=PdfLoader.js.map