var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
import React, { Component } from "react";
var clamp = function (value, left, right) {
    return Math.min(Math.max(value, left), right);
};
var TipContainer = /** @class */ (function (_super) {
    __extends(TipContainer, _super);
    function TipContainer() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.state = {
            height: 0,
            width: 0,
        };
        _this.node = null;
        _this.updatePosition = function () {
            if (!_this.node) {
                return;
            }
            var _a = _this.node, offsetHeight = _a.offsetHeight, offsetWidth = _a.offsetWidth;
            _this.setState({
                height: offsetHeight,
                width: offsetWidth,
            });
        };
        return _this;
    }
    TipContainer.prototype.componentDidUpdate = function (nextProps) {
        if (this.props.children !== nextProps.children) {
            this.updatePosition();
        }
    };
    TipContainer.prototype.componentDidMount = function () {
        setTimeout(this.updatePosition, 0);
    };
    TipContainer.prototype.render = function () {
        var _this = this;
        var _a = this.props, children = _a.children, style = _a.style, scrollTop = _a.scrollTop, pageBoundingRect = _a.pageBoundingRect;
        var _b = this.state, height = _b.height, width = _b.width;
        var isStyleCalculationInProgress = width === 0 && height === 0;
        var shouldMove = style.top - height - 5 < scrollTop;
        var top = shouldMove ? style.bottom + 5 : style.top - height - 5;
        var left = clamp(style.left - width / 2, 0, pageBoundingRect.width - width);
        var childrenWithProps = React.Children.map(children, function (child) {
            // @ts-ignore
            return React.cloneElement(child, {
                onUpdate: function () {
                    _this.setState({
                        width: 0,
                        height: 0,
                    }, function () {
                        setTimeout(_this.updatePosition, 0);
                    });
                },
                popup: {
                    position: shouldMove ? "below" : "above",
                },
            });
        });
        return (React.createElement("div", { className: "PdfHighlighter__tip-container", style: {
                visibility: isStyleCalculationInProgress ? "hidden" : "visible",
                top: top,
                left: left,
            }, ref: function (node) {
                _this.node = node;
            } }, childrenWithProps));
    };
    return TipContainer;
}(Component));
export default TipContainer;
//# sourceMappingURL=TipContainer.js.map